/*
TASK: rings
LANG: C++
*/

#include <iostream>
#include <queue>
#include <vector>
#define ii pair<int, int>

using namespace std;

vector<int> G[1010];
int n;
int start, end;

int bfs(int s) {
  vector<bool> used(n+3, false);
  vector<int> p(n+3, -9999);
  used[s] = true;
  
  queue<int> q;
  q.push(s);
  p[s] = 0;
  
  while(q.size()) {
    int curr = q.front();
    q.pop();
    
    int l = p[curr];
    
    if(curr == end)
      break;
    
    for(int i=0;i<G[curr].size(); i++) 
      if(!used[G[curr][i]]) {
        used[G[curr][i]] = true;
        q.push(G[curr][i]);
        p[G[curr][i]] = l+1;
      }
  }
  
  int res = p[end];
  
  queue<ii> back;
  back.push(ii(end, res));
  vector<int> u(n+3, false);
  u[end] = true;
  int st = 1;
  
//  for(int i=0;i<=n; i++)
//    cout<<p[i]<<" ";
//  cout<<endl;
  
  while(back.size()) {
    ii tmp = back.front();
    back.pop();
    int curr = tmp.first, des = tmp.second - 1;
//    cout<<curr<<" "<<des<<endl;
    
    for(int i=0;i<G[curr].size(); i++) 
      if(!u[G[curr][i]] && p[G[curr][i]] == des ) {
        u[G[curr][i]] = true;
        back.push(ii(G[curr][i], des));
        st++;
      }
  }
  
  return n-st;
  
}

int main(){
  int m;
  
  cin>>n>>m;
  for(int i=0;i<m;i++) {
    int u, v;
    cin>>u>>v;
    G[u].push_back(v);
    G[v].push_back(u);
  } 
  cin>>start>>end;
  
  cout<<bfs(start)<<" ";
  cin>>start>>end;
  cout<<bfs(start)<<endl;
  
  return 0;
}
